// --- [ interrupt.S ] --------------------------------------------------------
//       12.12.13
//       tab = 3
// ASM Interrupt-Routinen - sparen 36 Byte ein

#include  "avr/io.h"
#include "global.h"


#if IRQ_IN_ASM == TRUE

.global TIM1_COMPA_vect
.global PCINT1_vect

// ----------------------------------------------------------------------------
// incrementiert die Variable overflow in GPIOR0
// schreibt TRUE (1) in GPIOR0 = Variable "new_tick"

.func TIM1_COMPA_vect
TIM1_COMPA_vect:

   push  R16

   ldi   R16, 1
   out   _SFR_IO_ADDR(GPIOR0), R16

   pop   R16

   reti

.endfunc


// ----------------------------------------------------------------------------
// wird durch einen PCINT1 aufgerufen
// schreibt TRUE (1) in GPIOR1 = Variable "state"

.func PCINT1_vect
PCINT1_vect:

   push  R16

   ldi   R16, 1
   out   _SFR_IO_ADDR(GPIOR1), R16

   pop   R16

   reti

.endfunc

#endif

// --- [ eof ] ----------------------------------------------------------------

